<?php			

	/**
	 *	Add new categories to database
	 * 
	 * 	For Admin use only
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	
	require "inc/includer.inc.php";
	require_once("inc/admin.inc.php");
	require_once("inc/guielements.inc.php");

	// Header senden
	$PageTitle = GetPageTitle(LANG_INPTTLADDCAT);
	include "inc/header.inc.php";
	

	$bError = FALSE;
	$strMessage = "";
	
	
	//
	// Securitycheck
	//
	if(!isset($_SESSION['admin']) || 
		md5("This_user_is_an_admin_from".$_SERVER['REMOTE_ADDR'])!=$_SESSION['admin'])	{
		
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=admin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	//
	// Process form data
	//
	if(isset($_POST['ready']) && strtoupper($_POST['ready'])=="YES")	{
		
		if(isset($_POST['f_addcategory']))	{
			
			// Convert input values
			$_POST['catname'] = toSafeString($_POST['catname']);
			$_POST['catdesc'] = toSafeString($_POST['catdesc']);
			$_POST['catlink'] = toSafeString($_POST['catlink']);
			$_POST['f_prevcat'] = toInt($_POST['f_prevcat']); 
			
			// Add Category... 
			if(empty($_POST['catname']))		{
				$bError = TRUE;
				$strMessage = LANG_NOCATEGORYSELECTED;
			} else {
				
				// Do it...
				if(GetConfig('OP_SIMPLE_CATS') && !TestCategory($_POST['catname']))	{
					$bError = TRUE;
					$strMessage = LANG_CATEGORYEXISTS;
				} else {
					// Check age rest value
					$bAgeRest = (isset($_POST['catAgeRest']) && 
						strtoupper($_POST['catAgeRest'])=="YES" ? true : false);
					
					// Add the category	
					if((AddCategoryByName($_POST['catname'], $_POST['catdesc'],
						$_POST['catlink'], $bAgeRest, $_POST['f_prevcat'])))	{
						
						$strMessage = ParseIn(LANG_CATINSERTSUCCESS,$_POST['catname']);
						
						// Update category cache
						require_once("inc/adv_categories.inc.php");
						require_once("inc/simple_categories.inc.php");
						
						//
						// Update main cache
						//
						$oCatManager = new CatTreeManager();
						$oCatManager->UpdateCache();
						$oRoot = $oCatManager->GetTreeRoot();
						
						$oTreeWork = new CategoryTreeWorks($oRoot);
						$oTreeWork->UpdateCategoryStatistics();
						
						//
						// Delete cache files from distributed cache
						//
						$oCatSimple = new SimpleCategoryManager();
						$oCatSimple->DeleteCache();	
						
					} else {
						$bError = TRUE;
						$strMessage = ParseIn(LANG_CATINSERTERROR,$_POST['catname']);
					}
				}				
			}			
		}
	
	} else { 
		$_POST['f_prevcat'] = -1;
		$_POST['catlink'] = "";
	}
	
	
	//
	// Display template
	//
	$OptionList=BuildCategorielistForListField();
	if($OptionList==false)	{
		$OptionList = "<option>&nbsp;</option>";	
	}

	if(GetConfig('OP_SIMPLE_CATS'))	{
		$PrevSelection = GetCategoriesForSelect($_POST['f_prevcat'],FALSE,true);
	} else {
		// Complexe cats
		require_once("inc/adv_categories.inc.php");
		
		$oCatManager = new CatTreeManager();
		$oRoot = $oCatManager->GetTreeRoot();
		$oTreeWork = new CategoryTreeWorks($oRoot);
		$PrevSelection = $oTreeWork->GetCategoryForSelect($_POST['f_prevcat'],TRUE);
	}
	$strLogoSelection = GetFilesFromDirectory(GetConfig('PD_DIRCATLOGOS'),$_POST['catlink'],TRUE);
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_addcategory.tpl.php";
	include "inc/footer.inc.php";
	
?>

