<?php	

	/**
	 *	Install database tables
	 * 
	 * 	Please change database settings in config.inc.php first 
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.50
	 * 
	 */
	

	require "inc/includer.inc.php";
	require "inc/configmanager.class.php";
	
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLADMININSTALLDB);
	include "inc/header.inc.php";
	
	$bError = false;
	$strMessage = "";
	$strLog = "";
	$oConfigMan = NULL;
	
	
	//
	// Read default configuration
	//
	$oConfigMan = new ConfigManager();
	
	//
	// Process installation
	//	
	if(isset($_POST['f_send']) && strtoupper($_POST['f_send'])=="YES")	{
		
		//
		// Handle input
		//
		
		// Convert parameters
		$_POST['f_database'] = toSafeString($_POST['f_database']);
		$_POST['f_host'] = toSafeString($_POST['f_host']);		
		$_POST['f_pass'] = toSafeString($_POST['f_pass']);
		$_POST['f_user'] = toSafeString($_POST['f_user']);
		$_POST['f_adminname'] = toSafeString($_POST['f_adminname']);
		$_POST['f_adminpass'] = toSafeString($_POST['f_adminpass']);

		
		$arrErrors = array();
		
		// Check mandatory
		if(empty($_POST['f_database']))		{
			$arrErrors[] = LANG_INSTALL_NO_DATABASE;
		} 
		
		if(empty($_POST['f_host']))	{
			$arrErrors[] = LANG_INSTALL_NO_HOST;			
		}
		
		if(empty($_POST['f_user']))	{
			$arrErrors[] = LANG_INSTALL_NO_USER;
		}
		
		if(empty($_POST['f_adminname']))	{
			$arrErrors[] = LANG_INSTALL_NO_ADMIN_NAME;
		}
		
		if(empty($_POST['f_adminpass']))	{
			$arrErrors[] = LANG_INSTALL_NO_ADMIN_PASS;
		}
				
		
		//
		// Start the configuration
		//		
		if(sizeof($arrErrors)==0)	{		

			// Override default database settings
			$GLOBALS['CONFIG']['DB_HOST'] = $_POST['f_host'];
			$GLOBALS['CONFIG']['DB_USER'] = $_POST['f_user'];
			$GLOBALS['CONFIG']['DB_PASS'] = $_POST['f_pass'];
			$GLOBALS['CONFIG']['DB_NAME'] = $_POST['f_database'];
			$GLOBALS['CONFIG']['DB_TYPE'] = 1;
			$GLOBALS['PERSIST_DB'] = "";
			
			//
			// Test/connect database
			//
			$DB = new SQLDatabase();
			$DB->dbconnect();
		
			if(!$DB->IsConnected())	{
				$bError = TRUE;
				$strLog = LANG_DBCONNECTERROR."<br>".
					$DB->GetErrorMessage();
			} elseif($DB->GetError()!=0)	{
				$bError = TRUE;
				$strLog = ParseIn(LANG_DBCOMMONERROR,$DB->GetErrorMessage())."<br>".
					$DB->GetErrorMessage();
			} 			
			
			
			//
			// Create tables, if user wants us to
			//
			if(!$bError && isset($_POST['f_createtables']) && (string)$_POST['f_createtables']=="1")	{
			
				$strLog.= LANG_INSTALL_COULD_CONNECT."<br>";

				// Create action table
				$sql = "CREATE TABLE `cf_actions` (
					`actionid` bigint(15) unsigned NOT NULL auto_increment,
				  	`actiontype` varchar(10) NOT NULL default 'UNKNOWN',
				  	`actionuserid` bigint(15) default NULL,
				  	`actiontext` text,
				  	`actiontime` datetime NOT NULL default '0000-00-00 00:00:00',
				  	UNIQUE KEY `actionid` (`actionid`),
				  	KEY `sorter` (`actiontype`,`actiontime`)
					) TYPE=MyISAM; ";
	
				$strLog.= ParseIn(LANG_TBLCREATER,"Actions table cf_actions")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
				
				
				// Create ad table
				$sql = "CREATE TABLE `cf_ads` (
				  `adid` bigint(15) unsigned NOT NULL auto_increment,
				  `adcat` bigint(10) NOT NULL default '0',
				  `adtype` tinyint(3) NOT NULL default '0',
				  `aduserid` bigint(15) unsigned NOT NULL default '0',
				  `adtitle` varchar(255) default NULL,
				  `adtext` text,
				  `adoutdate` datetime default NULL,
				  `adindate` datetime NOT NULL default '0000-00-00 00:00:00',
				  `adeditdate` datetime default '0000-00-00 00:00:00',
				  `adzip` varchar(10) default NULL,
				  `adcountry` varchar(50) default NULL,
				  `adname` varchar(50) default NULL,
				  `ademail` varchar(150) default NULL,
				  `adfax` varchar(25) default NULL,
				  `adtel` varchar(25) default NULL,
				  `adlang` varchar(6) default NULL,
				  `adcity` varchar(50) default NULL,
				  `admobile` varchar(30) default NULL,
				  `adipadress` varchar(20) default NULL,
				  `adpiclink` varchar(255) default NULL,
				  `adviewed` int(9) unsigned default '0',
				  `adhomepage` varchar(200) default NULL,
				  `adfeatured` tinyint(1) unsigned default '0',
				  `adchecked` tinyint(1) unsigned default '0',
				  `adtellcounter` int(6) unsigned default '0',
				  `adcontcounter` int(6) unsigned default '0',
				  `adicq` varchar(15) default '',
				  `adaim` varchar(40) default NULL,
				  `adskype` varchar(40) default NULL,
				  `admsn` varchar(40) default NULL,
				  `adyahoo` varchar(40) default NULL,
				  `adagerestricted` tinyint(1) unsigned default '0',
				  PRIMARY KEY  (`adid`),
				  KEY `adcat` (`adcat`),
				  KEY `adindate` (`adindate`),
				  KEY `adchecked` (`adchecked`),
				  KEY `adfeatured` (`adfeatured`),
				  KEY `adtitle` (`adtitle`(50)),
				  KEY `adtype` (`adtype`),
				  FULLTEXT KEY `adtext` (`adtext`)
				) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"Ad table cf_ads")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
				
				
				// Create picture table			
				$sql = "CREATE TABLE `cf_pictures` (
				  `plid` int(11) NOT NULL auto_increment,
				  `pladid` int(11) NOT NULL default '0',
				  `pltitle` varchar(100) NOT NULL default '',
				  `pllink` varchar(80) NOT NULL,
				  `plinsertdate` datetime NOT NULL,
				  `plreleased` tinyint(1) NOT NULL default '0',
				  PRIMARY KEY  (`plid`),
				  KEY `pladid` (`pladid`),
				  KEY `plreleased` (`plreleased`)
				) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"picture detail table cf_pictures")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};			
				
				
				// Create free field table
				$sql = "CREATE TABLE `cf_adfreerows` (
				  	`freeid` mediumint(9) unsigned NOT NULL auto_increment,
				  	`adid` bigint(15) unsigned NOT NULL default '0',
				  	`freecol01` text,
				  	`freecol02` text,
				  	`freecol03` text,
				  	`freecol04` text,
				  	`freecol05` text,
				  	`freecol06` text,
				  	`freecol07` text,
				  	`freecol08` text,
				  	`freecol09` text,
				  	`freecol10` text,
				  	`freecoldesc` text,
				  	UNIQUE KEY `freeid` (`freeid`),
				  	KEY `adid` (`adid`)
					) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"Ad free field table cf_adfreerows")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
				
				// Create category table			
				$sql = "CREATE TABLE `cf_categories` (
				  `catid` int(10) unsigned NOT NULL auto_increment,
				  `catname` varchar(255) default NULL,
				  `catprev` int(10) default NULL,
				  `catlang` varchar(6) default NULL,
				  `catdesc` varchar(255) default NULL,
				  `caticonlink` varchar(255) default NULL,
				  `catagerestricted` tinyint(1) unsigned default '0',
				  `cateditdate` datetime default NULL,
				  `catpresort` tinyint(1) NOT NULL default '0',
				  PRIMARY KEY  (`catid`),
				  KEY `catprev` (`catprev`)
				) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"category table cf_categories")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};						
				
				
				// Create category statistics table			
				$sql = "CREATE TABLE `cf_catstats` (
				  `statid` int(11) NOT NULL auto_increment,
				  `statcatid` int(11) default NULL,
				  `statlevel` tinyint(3) unsigned NOT NULL default '0',
				  `statadcount` int(11) unsigned NOT NULL default '0',
				  `statadcountcum` int(11) unsigned NOT NULL default '0',
				  `statchildcatcount` int(11) unsigned NOT NULL default '0',
				  `statlastin` datetime NOT NULL,
				  `statlastincum` datetime NOT NULL,
				  `statupdate` datetime NOT NULL,
				  `statguid` varchar(40) NOT NULL,
				  PRIMARY KEY  (`statid`),
				  KEY `category` (`statcatid`)
				) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"category statistics table cf_categories")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};					
				
					
				// Create security table
				$sql = "CREATE TABLE `cf_secsub` (
					`scsid` int(6) unsigned NOT NULL auto_increment,
					`scsadid` bigint(15) NOT NULL default '0',
					`scspassword` varchar(60) NOT NULL default '',
					UNIQUE KEY `scsid` (`scsid`)
					) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"security table cf_secsub")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};					
				
				// Create user table
				$sql = "CREATE TABLE `cf_users` (
				  `userid` bigint(15) unsigned NOT NULL auto_increment,
				  `username` varchar(100) default NULL,
				  `userpass` varchar(60) default NULL,
				  `useralterpass` varchar(60) default NULL,
				  `userrights` tinyint(3) unsigned default '0',
				  `userdeflang` varchar(5) default NULL,
				  `userblocked` tinyint(1) default '0',
				  `userreleased` tinyint(1) NOT NULL default '1',
				  `userrealname` varchar(100) default NULL,
				  `useradress1` varchar(150) default NULL,
				  `useradress2` varchar(150) default NULL,
				  `usertitle` varchar(20) default NULL,
				  `userzip` varchar(10) default NULL,
				  `usercity` varchar(70) default NULL,
				  `usertel` varchar(30) default NULL,
				  `usermobile` varchar(35) default NULL,
				  `userlastlogin` datetime default NULL,
				  `usereditdate` datetime default NULL,
				  `usercreatedate` datetime default NULL,
				  `usercountry` varchar(100) default NULL,
				  `useremail` varchar(100) NOT NULL default '',
				  `useremailhtml` tinyint(1) NOT NULL default '1',
				  `userfax` varchar(35) default NULL,
				  `userhomepage` varchar(100) default NULL,
				  `usericq` varchar(15) default NULL,
				  `userskype` varchar(40) default NULL,
				  `usermsn` varchar(40) default NULL,
				  `useryahoo` varchar(40) default NULL,
				  `useraim` varchar(40) default NULL,
				  `useripaddress` varchar(20) default NULL,
				  `usermaxadnumber` int(5) unsigned default '0',
				  `useragechecked` tinyint(1) unsigned NOT NULL default '0',
				  `useropenamount` decimal(11,2) default '0.00',
				  `userlogins` int(9) unsigned NOT NULL default '0',
				  `userreleasecode` varchar(40) default NULL,
				  `userpasswordset` datetime default NULL, 
				  UNIQUE KEY `userid` (`userid`),
				  KEY `useremail` (`useremail`)
				) TYPE=MyISAM;";
								
				$strLog.= ParseIn(LANG_TBLCREATER,"user table cf_users")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};	
				
				// Create configuration table and insert default configuration
				$sql = "CREATE TABLE `cf_config` (
				  	`configid` int(11) NOT NULL auto_increment,
				  	`configname` varchar(50) NOT NULL,
				  	`configspec` text NOT NULL,
				 	`configdefault` tinyint(1) NOT NULL default '0',
				  	`configactive` tinyint(1) NOT NULL default '0',
				  	`configeditdate` datetime default NULL,
				  	`configversion` int(11) NOT NULL default '1',
				  	PRIMARY KEY  (`configid`)
					) TYPE=MyISAM;";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"configuration table cf_config")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};	
				
				$sql =  "INSERT INTO cf_config
   					(`configid`, `configname`, `configspec`, `configdefault`, `configactive`, `configeditdate`, `configversion`)
					VALUES
   					(1, 'ClassAd standard configuration', 'a:81:{s:7:\"DB_NAME\";s:0:\"\";s:7:\"DB_HOST\";s:9:\"127.0.0.1\";s:7:\"DB_USER\";s:4:\"root\";s:7:\"DB_PASS\";s:0:\"\";s:7:\"DB_TYPE\";s:1:\"1\";s:9:\"ADMINNAME\";s:5:\"admin\";s:9:\"ADMINPASS\";s:32:\"21232f297a57a5a743894a0e4a801fc3\";s:13:\"LY_STYLESHEET\";s:16:\"styles/green.css\";s:20:\"LY_ENABLEARTICLEPICS\";b:1;s:15:\"LY_GD_VERSION_2\";b:1;s:18:\"LY_THUMBNAIL_WIDTH\";s:2:\"75\";s:19:\"LY_THUMBNAIL_HEIGHT\";s:2:\"75\";s:16:\"LY_MAX_PIC_WIDTH\";s:3:\"500\";s:17:\"LY_MAX_PIC_HEIGHT\";i:500;s:17:\"LY_ALLOW_UPSIZING\";b:0;s:17:\"LY_MAX_LISTLENGTH\";i:20;s:27:\"LY_ARTLIST_VARIABLE_BGCOLOR\";b:1;s:18:\"LY_MAX_UPLOAD_SIZE\";s:3:\"300\";s:18:\"LY_SORT_ORDER_CATS\";s:1:\"2\";s:19:\"LY_BIG_PICTURE_MODE\";b:0;s:12:\"ML_ADMINCOPY\";b:0;s:13:\"ML_ADMINEMAIL\";s:18:\"admin@somehost.com\";s:18:\"ML_RESPONDVIAEMAIL\";b:0;s:14:\"ML_SENDER_NAME\";s:18:\"Kleinanzeigenmarkt\";s:14:\"ML_SENDER_ADDR\";s:20:\"someone@somehost.com\";s:9:\"ML_DOMAIN\";s:12:\"somehost.com\";s:13:\"ML_EMAIL_HTML\";b:1;s:22:\"ML_PROVIDER_SHORT_INFO\";s:28:\"My Name, My Address, My City\";s:9:\"PD_WEBURL\";s:16:\"www.somehost.com\";s:13:\"PD_SCRIPTPATH\";s:12:\"classifieds/\";s:15:\"PD_USERGRAPHICS\";s:13:\"usergraphics/\";s:17:\"PD_SCRIPTGRAPHICS\";s:9:\"graphics/\";s:14:\"PD_DIRCATLOGOS\";s:9:\"catlogos/\";s:17:\"PD_EMAILTEMPLATES\";s:15:\"emailtemplates/\";s:11:\"PD_CACHEDIR\";s:6:\"cache/\";s:13:\"RSS_MAX_COUNT\";i:20;s:9:\"RSS_TITLE\";s:26:\"Latest ads from www.xyz.de\";s:15:\"RSS_DESCRIPTION\";s:69:\"The latest ads from www.xyz.de. Classified ads for all kind of goods.\";s:8:\"RSS_ICON\";s:9:\"world.jpg\";s:7:\"RSS_TTL\";i:60;s:18:\"SEC_FORCE_AGE_REST\";b:1;s:21:\"SEC_HIDE_AGEREST_CATS\";b:1;s:20:\"SEC_HIDE_AGEREST_ADS\";b:1;s:15:\"SEC_SUB_UNKNOWN\";b:0;s:19:\"SEC_DIR_SUB_UNKNOWN\";b:0;s:16:\"SEC_DIR_SUB_USER\";b:0;s:20:\"SEC_DIR_SUB_AUTHUSER\";b:1;s:22:\"SEC_DIR_SUB_COMMERCIAL\";b:1;s:18:\"SEC_SUB_ADMIN_INFO\";b:1;s:17:\"SEC_REGUSER_OPTIN\";b:1;s:18:\"SEC_MAX_TELL_COUNT\";s:2:\"20\";s:19:\"SEC_USE_PIC_RELEASE\";b:1;s:19:\"SEC_MAX_PICS_PER_AD\";i:5;s:14:\"OP_SIMPLE_CATS\";s:1:\"0\";s:20:\"OP_COMPLEX_CATS_COLS\";s:1:\"2\";s:22:\"OP_COMPLEX_CATS_MAXSUB\";s:1:\"5\";s:29:\"OP_COMPLEX_CATS_SUB_ART_COUNT\";b:1;s:27:\"OP_COMPLEX_CATS_BUILD_ORDER\";s:1:\"1\";s:21:\"OP_BUILD_FEATURED_ADS\";b:1;s:24:\"OP_BUILD_FEATURED_NO_ADS\";s:1:\"3\";s:19:\"OP_BUILD_LATEST_ADS\";b:1;s:22:\"OP_BUILD_LATEST_NO_ADS\";s:1:\"5\";s:22:\"OP_SHOW_PAGE_BUILDTIME\";b:1;s:10:\"DOMAINNAME\";s:12:\"somehost.com\";s:6:\"TELLAD\";b:1;s:10:\"ICQCONTACT\";b:0;s:7:\"CRONJOB\";b:0;s:20:\"MAINTAIN_PROBABILITY\";i:100;s:18:\"AUTODELETEOUTDATED\";b:0;s:13:\"ALLOW_CACHING\";b:1;s:13:\"UNLIMITED_ADS\";b:1;s:15:\"USE_FREE_FIELDS\";b:0;s:15:\"BUFFERED_OUTPUT\";b:1;s:7:\"DEFLANG\";s:3:\"GER\";s:10:\"DEFCOUNTRY\";s:1:\"D\";s:11:\"DEFMAILLANG\";s:3:\"GER\";s:5:\"DEBUG\";b:0;s:7:\"VERSION\";s:4:\"4.50\";s:17:\"LY_RSS_MAX_LENGTH\";i:200;s:14:\"RSS_MAX_LENGTH\";i:200;s:23:\"SEC_USE_PICTURE_RELEASE\";b:0;}', 1, 0, \"2000-01-01 19:45:45\", 1)";
				
				$iInsertId = $DB->dbinsert($sql);
				if($iInsertId<=0)	{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_INSTALL_INSERT_ERR,"cf_config",$DB->GetErrorMessage());
				}
							
			}	// Create tables

			if(!$bError)	{
				// Read best possible configuration and set new values
				if(!$oConfigMan->ReadSpecialConfig(CONFIGMANAGER_ACTIVE))	{
					
					if(!$oConfigMan->ReadSpecialConfig(CONFIGMANAGER_DEFAULT))	{
						$bError = TRUE;
						$strLog.= "Missing active / default configuration(s).";
						$strMessage = "No base configuration found. Please make sure database tables are installed correctly.";
					}
				}
			}
			
			if(!$bError)	{
				
				$oConfigMan->SetConfigVar("DB_NAME",$_POST['f_database']); 
				$oConfigMan->SetConfigVar("DB_HOST",$_POST['f_host']);
				$oConfigMan->SetConfigVar("DB_USER",$_POST['f_user']);
				$oConfigMan->SetConfigVar("DB_PASS",$_POST['f_pass']);
				$oConfigMan->SetConfigVar("ADMINNAME",$_POST['f_adminname']);
				$oConfigMan->SetConfigVar("ADMINPASS",md5($_POST['f_adminpass']));
				
				// Update configuration in database and compile the config file	
				$oConfigMan->UpdateConfig(CONFIGMANAGER_ACTIVE);
				$oConfigMan->SaveConfigToFile("config/config.inc.php",TRUE);			
				
				if($bError)		{
					$strMessage = LANG_DBINSTALLFAILED;	
				} else {
					$strMessage = LANG_DBINSTALLOKAY;		
				}
			}
					
		} else {
			
			// Validation error
			$bError = TRUE;
			$strMessage = "<ul>";
			foreach($arrErrors as $element)	{
				$strMessage.= "<li>".$element."</li>";
			}
			$strMessage.= "</ul>";			
		}
		
	} else {

		// First display
		// Set defaults	
		$_POST['f_database'] = GetConfig("DB_NAME");
		$_POST['f_host'] = GetConfig("DB_HOST");
		$_POST['f_user'] = GetConfig("DB_USER");
		$_POST['f_pass'] = GetConfig("DB_PASS");
		$_POST['f_adminname'] = GetConfig("ADMINNAME");
		$_POST['f_adminpass'] = "";
		
		$_POST['f_createtables'] = "1";
		
	}
	
	//
	// Display template
	//
	$strGraphicInfo = GetConfig("PD_CACHEDIR")." - ".
		(is_writable(GetConfig("PD_CACHEDIR")."empty.dir")?"<span class=\"correctText\">".LANG_INSTALL_WRITABLE."</span>":
		"<span class=\"failureText\">".LANG_INSTALL_NOT_WRITABLE."</span>");
	$strCacheInfo = GetConfig("PD_USERGRAPHICS")." - ".
		(is_writable(GetConfig("PD_USERGRAPHICS")."empty.dir")?"<span class=\"correctText\">".LANG_INSTALL_WRITABLE."</span>":
		"<span class=\"failureText\">".LANG_INSTALL_NOT_WRITABLE."</span>");
	$strConfigInfo = "config/config.inc.php - ".
		(is_writable("config/config.inc.php")?"<span class=\"correctText\">".LANG_INSTALL_WRITABLE."</span>":
		"<span class=\"failureText\">".LANG_INSTALL_NOT_WRITABLE."</span>");	
		
	
	if(!function_exists("gd_info"))	{
		$strGdInfo = "<span class=\"failureText\">".LANG_INSTALL_GD_NOT_AVAIL."</span>";
	} else {
			
		// Get GD information	
		$arrInfo = gd_info();
		$iVersion = (preg_match("/(2.)/i",$arrInfo['GD Version'])==0?1:2);
		$bGifReadSupport = $arrInfo['GIF Read Support']; 
		$bGifWriteSupport = $arrInfo['GIF Create Support'];
		$bJpegSupport = $arrInfo['JPG Support'];
		$bPngSupport = $arrInfo['PNG Support'];
		$bWbmpSupport = $arrInfo['WBMP Support'];
		
		$strVersionInfo = ($iVersion==2?"2.x":"1.x")." (".
			($bGifReadSupport?"GIF-Read, ":"").
			($bGifWriteSupport?"GIF-Write, ":"").
			($bJpegSupport?"JPEG, ":"").
			($bPngSupport?"PNG, ":"").
			($bWbmpSupport?"WBMP":"").
			")";
			
		$strGdInfo = "<span class=\"correctText\">".ParseIn(LANG_INSTALL_GD_OK,$strVersionInfo)."</span>";
	}
	
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_install.tpl.php";
	include "inc/footer.inc.php";


?>