<?php	

	/**
	 *	Install database tables
	 * 
	 * 	Please change database settings in config.inc.php first 
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLADMINUPDATEDB);
	include "inc/header.inc.php";
	
	$bError = false;
	$strMessage = "";
	$strLog = "";
	
	$strServer = GetConfig('DB_HOST');
	$strDatabase = GetConfig('DB_NAME');
	$strDatabaseUser = GetConfig('DB_USER');
	
	
	//
	// Process installation
	//	
	if(isset($_POST['f_send']) && strtoupper($_POST['f_send'])=="YES")	{
		
		//
		// Check mandatory settings
		//
		if(empty($strServer) || empty($strDatabase))	{
			$bError = TRUE;
			$strLog = "Please check database server/host and database settings in file inc/config.inc.php";
		}
		
		if(!$bError)	{		
		
			// Connect database
			$DB = new SQLDatabase();
			$DB->dbconnect();
		
			if(!$DB->IsConnected())	{
				$bError = TRUE;
				$strLog = LANG_DBCONNECTERROR."<br>".
					$DB->GetErrorMessage();
			} elseif($DB->GetError()!=0)	{
				$bError = TRUE;
				$strLog = ParseIn(LANG_DBCOMMONERROR,$DB->GetErrorMessage())."<br>".
					$DB->GetErrorMessage();
			} else {
				
				//
				// Update action table
				//
				$sql = "ALTER TABLE cf_actions 
					MODIFY actiontime datetime NOT NULL default '2000-01-01' ";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"Action table cf_actions")."<br>";
				if(!$DB->dbtablealter($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};

							
				//
				// Update ad table
				//
				$sql = "ALTER TABLE cf_ads 
					ADD COLUMN adtype tinyint(3) NOT NULL default '0',
					ADD COLUMN adaim varchar(40) default NULL,
					ADD COLUMN adskype varchar(40) default NULL,
					ADD COLUMN admsn varchar(40) default NULL,
					ADD COLUMN adyahoo varchar(40) default NULL,
					MODIFY adtellcounter int(6) unsigned default '0',
					MODIFY adcontcounter int(6) unsigned default '0',
					MODIFY adviewed int(9) unsigned default '0',
					MODIFY adindate datetime NOT NULL default '2000-01-01',
					MODIFY adeditdate datetime default '2000-01-01',
					CHANGE city adcity varchar(50) default NULL,
					CHANGE adplz adzip varchar(10) default NULL,
					ADD INDEX adchecked (adchecked),
					ADD INDEX adfeatured (adfeatured),
					ADD INDEX adtitle (adtitle(50)),
					ADD INDEX adtype (adtype),
					ADD FULLTEXT adtext (adtext)";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"Ad table cf_ads")."<br>";
				if(!$DB->dbtablealter($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
					
				
				//
				// Update category table
				//
				$sql = "ALTER TABLE cf_categories 
					ADD COLUMN cateditdate datetime default NULL, 
					ADD COLUMN catpresort tinyint(1) NOT NULL default '0',
					CHANGE lang catlang varchar(6) default NULL,
					CHANGE iconlink caticonlink varchar(255) default NULL";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"Category table cf_categories")."<br>";
				if(!$DB->dbtablealter($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
					
					
				//
				// Insert missing category statistic table
				//	
				$sql = "CREATE TABLE `cf_catstats` (
				  `statid` int(11) NOT NULL auto_increment,
				  `statcatid` int(11) default NULL,
				  `statlevel` tinyint(3) unsigned NOT NULL default '0',
				  `statadcount` int(11) unsigned NOT NULL default '0',
				  `statadcountcum` int(11) unsigned NOT NULL default '0',
				  `statchildcatcount` int(11) unsigned NOT NULL default '0',
				  `statlastin` datetime NOT NULL,
				  `statlastincum` datetime NOT NULL,
				  `statupdate` datetime NOT NULL,
				  `statguid` varchar(40) NOT NULL,
				  PRIMARY KEY  (`statid`),
				  KEY `category` (`statcatid`)
				) ENGINE=MyISAM DEFAULT CHARSET=latin1";

				$strLog.= ParseIn(LANG_TBLCREATER,"Category statistics table cf_catstats")."<br>";
				if(!$DB->dbtablecreate($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
				
				
				//
				// Update user table
				//	
				$sql = "ALTER TABLE cf_users 
					DROP COLUMN userpayment, 
					DROP COLUMN useraccountno, 
					DROP COLUMN userbankname,
					DROP COLUMN userbankcode,
					DROP COLUMN usermoney,
					DROP COLUMN userinvoiceemail,
					DROP COLUMN useropenamount";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"User table cf_users (dropping unnecessary fields")."<br>";
				if(!$DB->dbtablealter($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};
				
				
				$sql = "ALTER TABLE cf_users 
					ADD COLUMN useralterpass varchar(60) default NULL,
					ADD COLUMN userreleased tinyint(1) NOT NULL default '1', 
					ADD COLUMN userreleasecode varchar(40) default NULL,
					ADD COLUMN userskype varchar(40) default NULL,
					ADD COLUMN usermsn varchar(40) default NULL,
					ADD COLUMN useryahoo varchar(40) default NULL,
					ADD COLUMN userpasswordset datetime default NULL,
					ADD COLUMN useraim varchar(40) default NULL";
				
				$strLog.= ParseIn(LANG_TBLCREATER,"User table cf_users (editing fields")."<br>";
				if(!$DB->dbtablealter($sql))		{
					$bError = TRUE;
					$strLog.= ParseIn(LANG_TBLCREATEERROR,$DB->GetErrorMessage())."<br>";
				};

			}
					
		}

		if($bError)		{
			$strMessage = LANG_DBINSTALLFAILED;
		} else {
			
			//
			// All tables created
			//
			$strMessage = LANG_DBINSTALLOKAY;
		}
		
	} else {

		// First display
		// Set defaults	
	
	}
	
	//
	// Display template
	//
	$strPassword = !empty(GetConfig('DB_PASS'))?"Yes":"No";

	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/admin_update.tpl.php";
	include "inc/footer.inc.php";
?>

