<?php			

	/**
	 *	Contact user about ad 
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */

	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");
	
	
	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLCONTACT); 
	include "inc/header.inc.php";
  	
	//
  	// Init variables
  	//
  	$nametest = TRUE;
	$yourmailtest = TRUE;
	$friendsemailtest = TRUE;
	$citytest = TRUE;
	$emailtest = TRUE;
	$texttest = TRUE;
	
	$bError = FALSE;
	$strMessage = "";
	$BreadCrumb = "";
	$iAdId = -1;
	
	
	if(isset($_GET['adid']))	{
		$iAdId = (integer)$_GET['adid'];
		$_SESSION['s_ContactId'] = $iAdId;
	} elseif(isset($_SESSION['s_ContactId']))	{
		$iAdId = (integer)$_SESSION['s_ContactId'];
	}
	
	if($iAdId <= 0)	{
		// Redirect user
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=index.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	// Get Article Details
	$data = GetArticleByID($iAdId);
	if(!is_array($data) || sizeof($data)==0)	{
		// Redirect user
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=index.php\">";
		include "inc/header.inc.php";
		die();
	}
	$element = $data[0];
	
	$CatArray = GetCategorieByID($element['adcat']);
	
	
	//
	// Process form
	//
	if(isset($_POST['ready']) && strtoupper($_POST['ready']) == "YES")		{
		
		// Convert input vars
		$_POST['name'] = toSafeString($_POST['name']);
		$_POST['tel'] = toSafeString($_POST['tel']);
		$_POST['fax'] = toSafeString($_POST['fax']);
		$_POST['email'] = toSafeString($_POST['email']);
		$_POST['zip'] = toSafeString($_POST['zip']);
		$_POST['city'] = toSafeString($_POST['city']);
		$_POST['country'] = toSafeString($_POST['country']);
		$_POST['text'] = toSafeString($_POST['text']);
		
		
		// Test mandatory fields
		if(empty($_POST['name']))	{ $nametest = FALSE; }
		if(empty($_POST['city']))	{ $citytest = FALSE; }
		if(empty($_POST['email']))	{ $emailtest = FALSE; }
		if(empty($_POST['text']))	{ $texttest = FALSE; }
				
		// If theres any problem with mandatory fields, give a response to user and let script die
		if($nametest==FALSE || $texttest==FALSE || $citytest==FALSE || $emailtest==FALSE)		{
			$bError = TRUE;
			$strMessage = LANG_NEWADMANDATORYERROR;
		}

		// Test Email-Adresses
		if (!$bError && !eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$", $_POST['email']))		{
			$emailtest = FALSE;		
			$bError = TRUE;
			$strMessage = LANG_NEWADEMAILERROR;
		}

		// Check captcha
		if(GetConfig("USE_CAPTCHA"))	{
			if(!$bError)	{
				if(!isset($_SESSION['CAPTCHA']) || 
					(sha1(strtoupper($_POST['f_captcha'])) != $_SESSION['CAPTCHA']['SOLUTION']))	{
					
					$ContactTest['captchatest'] = FALSE;
					$bError = TRUE;
					$strMessage = LANG_CAPTCHA_ERROR;
				}			
			}
		}
			
		if(!$bError)	{		
			
			require_once("inc/postoffice.class.php");
			$oPO = new PostOfficeAdContact($iAdId);

			// Set contact info to postoffice		
			$arrContact = array(	"ContText"		=> $_POST['text'],
									"ContName"		=> $_POST['name'],
									"ContCountry"	=> $_POST['country'],
									"ContZip"		=> $_POST['zip'],
									"ContCity"		=> $_POST['city'],
									"ContPhone"		=> $_POST['tel'],
									"ContFax"		=> $_POST['fax'],
									"ContEmail"		=> $_POST['email']	);
			$oPO->SetContact($arrContact);						
			$bSuccess = $oPO->Send();						

			// Test for success		
			if($bSuccess)	{
				
				unset($_SESSION['CAPTCHA']);
				
				// Update contact counter
				AddCounter($iAdId,2,1);
				
				// Everything worked properly
				$strMessage = LANG_SENDMAILSUCCESS;
							
				// Link to submitted ad, but only, if direct submit was allowed
				$strMessage.=  "<br><a href=\"showad.php?adid=".$iAdId."\">".LANG_LINKTOSPECARTICLE."</a>".
					"<br><a href=\"showads.php?catid=".$element['adcat']."\">".ParseIn(LANG_LINKTOSPECCAT, $element['catname'])."</a>";				
				
				include "templates/".$GLOBALS['ACTIVELANGUAGE']."/success.tpl.php";
				include "inc/footer.inc.php";
				die();
				
			} else {
				$bError = TRUE;
				$strMessage = LANG_SENDMAILFAILED;
			}
		}
			
	} else 	{

		if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))		{

			$_POST['name'] = $_SESSION['s_UserInfo']['userrealname'];
			$_POST['zip'] = $_SESSION['s_UserInfo']['userzip']; 
			$_POST['city'] = $_SESSION['s_UserInfo']['usercity'];
			$_POST['country'] = $_SESSION['s_UserInfo']['usercountry'];
			$_POST['tel'] = $_SESSION['s_UserInfo']['usertel'];
			$_POST['fax'] = $_SESSION['s_UserInfo']['userfax'];
			$_POST['email'] = $_SESSION['s_UserInfo']['useremail'];	

		} else {
			$_POST['country'] = GetConfig('DEFCOUNTRY');
		}
		
		if(GetConfig("USE_CAPTCHA"))	{
			
			// Create new captcha
			require_once("inc/textcaptcha.class.php");
			
			$oCaptcha = new TextCaptcha();
			$oCaptcha->SetMaxChars(GetConfig("CAPTCHA_CHARS"));
			$oCaptcha->BuildCaptcha();
			$_SESSION['CAPTCHA'] = array( 	"QUESTION"	=> $oCaptcha->GetQuestion(),
											"SOLUTION"	=> sha1(strtoupper($oCaptcha->GetSolution()))	);
		}		
	}
	
	
	//
	// Display form
	//
		
	// Build links
	$LinkArticle = "<a href=\"showad.php?adid=".$iAdId."\">".LANG_LINKTOSPECARTICLE."</a>";
	$BreadCrumb =  "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		BuildCatHistory($CatArray['catid']).
		"&nbsp;&gt;&nbsp;".
		"<a href=\"showad.php?adid=".$iAdId."\">".$element['adtitle']."</a>".
		"&nbsp;&gt;&nbsp;".
		LANG_TTLCONTACT; 
	$strCountrySelect = GetCountriesForDropDown($_POST['country']);
		
	// Build error icon
  	$ImgError = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."x.gif\" valign=\"center\">";
	
  	$strAdTitle = $element['adtitle'];
	$strAdThumbLink = (!empty($element['adpiclink'])?
		GetConfig('PD_USERGRAPHICS')."tn_".$element['adpiclink']:
		GetConfig('PD_SCRIPTGRAPHICS')."no_image.jpg");
  	
	// Add captcha
	if(GetConfig("USE_CAPTCHA"))		{
		$strCaptcha = $_SESSION['CAPTCHA']['QUESTION'];
	}	
		
	// Show templates
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/contactad.tpl.php";
	include "inc/footer.inc.php";
	
?>