<?php

	
	class ExportBase	{
		
		var $strExportText = "";
		var $bBuildFieldNames = TRUE;
		
		var $CRLF = "\r\n";
		
		function GetExportText()	{	
			return $this->strExportText;	
		}
		
		function SetBuildFieldNames($bBuild)	{
			$this->bBuildFieldNames = $bBuild;
			return TRUE;
		}
		
		
		function DownloadData($strFilename="export.csv")	{
				
			if(!headers_sent())	{	

				header("Cache-Control: public, must-revalidate");
				header("Pragma: hack");
				header("Content-Type: application/octet-stream",FALSE);
				header("Content-Length: ".(string)strlen($this->strExportText));
				header("Accept-Ranges: bytes");
				header("Content-Disposition: attachment; filename=\"".$strFilename."\"");
		   		header("Content-Transfer-Encoding: binary\n");
				
				
				// Open file and read buffer   			
				print $this->strExportText;
				die();
			}
			echo "Downloading failed...";
  			return FALSE;	
		}
		
		/**
		 * Remove all critical characters
		 * 
		 * @param string Text to convert
		 * @return string Converted text
		 */
		function ConvertCsvText($strText) {
			$strText = str_replace(array("\r\n", "\r", "\n"), "<br />", $strText);
			$strText = str_replace(array("'",";")," ",$strText);
			return $strText;
		}
		
	}
	

	class AdExport extends ExportBase {
		
		function GetData()	{	
			
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{
				return FALSE;
			}
			
			$sql = "SELECT cf_ads.*, cf_categories.catname 
				FROM cf_ads
				LEFT OUTER JOIN cf_categories ON cf_categories.catid=cf_ads.adcat
				ORDER BY adid";
			$data = $DB->dbselect($sql);
			
			if(!is_array($data))	{
				return FALSE;
			} else {
				$this->ConvertToCSV($data);
			}
			return TRUE;				
		}
		
		
		function ConvertToCSV($arrData)	{
			
			$this->strExportText = "";
			
			if($this->bBuildFieldNames)	{
				
				$this->strExportText .= 
					"'adid';'adcat';'aduserid';'categoryname';'adtitle';'adtext';'adindate';'adoutdate';'adtype';".
					"'adname';'adzipcode';'adcity';'adcountry';'adphone';'adfax';'admobile';'ademail';".
					"'adicq';'admsn';'adyahoo';'adskype';'adaim';".
					"'adipaddress';'adviews';'adcontacts';'adtells';'adagerestricted'".$this->CRLF;
			}
			
			foreach($arrData as $element)	{
				$this->strExportText .= 
					"'".$element['adid']."';'".$element['adcat']."';'".$element['aduserid']."';'".$element['catname']."';'".$this->ConvertCsvText($element['adtitle'])."';".
					"'".$this->ConvertCsvText($element['adtext'])."';'".$element['adindate']."';'".$element['adoutdate']."';'".$element['adtype']."';'".$element['adname']."';".
					"'".$element['adzip']."';'".$element['adcity']."';'".$element['adcountry']."';'".$element['adtel']."';'".$element['adfax']."';".
					"'".$element['admobile']."';'".$element['ademail']."';'".$element['adicq']."';'".$element['admsn']."';'".$element['adyahoo']."';".
					"'".$element['adskype']."';'".$element['adaim']."';'".$element['adipadress']."';'".$element['adviewed']."';'".$element['adcontcounter']."';".
					"'".$element['adtellcounter']."';'".($element['adagerestricted']?"1":"0")."'".$this->CRLF;
			}
			return TRUE;			
		}
	}

	
	class UserExport extends ExportBase {
		
		function GetData()		{
			
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{
				return FALSE;
			}
			
			$sql = "SELECT cf_users.* 
				FROM cf_users
				ORDER BY userid";
			$data = $DB->dbselect($sql);
			
			if(!is_array($data))	{
				return FALSE;
			} else {
				$this->ConvertToCSV($data);
			}
			return TRUE;			
		}
		
		
		function ConvertToCSV($arrData)		{
			
			$this->strExportText = "";
			
			if($this->bBuildFieldNames)	{
				$this->strExportText .= 
					"'userid';'username';'userrights';'userdeflang';'userblocked';'userreleased';'userrealname';".
					"'useraddress1';'useraddress2';'usertitle';'userzipcode';'usercity';'usercountry';".
					"'userphone';'userfax';'usermobile';'useremail';'userhomepage';'usericq';'userskype';'useraim';".
					"'useryahoo';'usermsn';'useragechecked';'userlogins';'usermaxadnumber'".$this->CRLF;		
			}
				
			foreach($arrData as $element)	{			

				$this->strExportText .= 
					"'".$element['userid']."';'".$element['username']."';'".$element['userrights']."';'".$element['userdeflang']."';".	
					"'".($element['userreleased']?"1":"0")."';'".$element['userrealname']."';'".$element['useradress1']."';".
					"'".$element['useradress2']."';'".$element['usertitle']."';'".$element['userzip']."';'".$element['usercity']."';".
					"'".$element['usercountry']."';'".$element['usertel']."';'".$element['userfax']."';'".$element['usermobile']."';".
					"'".$element['useremail']."';'".$element['userhomepage']."';'".$element['usericq']."';'".$element['userskype']."';".
					"'".$element['useraim']."';'".$element['useryahoo']."';'".$element['usermsn']."';'".$element['useragechecked']."';".
					"'".$element['userlogins']."';'".$element['usermaxadnumber']."'".$this->CRLF;
			}
			return TRUE;
		}

	}
	
?>