<?php


if (!defined('__SIMPLE_CATEGORIES_INC__')) {
    define('__SIMPLE_CATEGORIES_INC__', 1);	

	//
	// ************** TODO: Funktionen fr Agerestricted einbauen und zur Zhlung aller Artikel
	// 
	class SimpleCategoryManager		{

		var $bAgeRestricted = FALSE;
		var $iSortOrder = CAT_ORDER_NAME;
		var $iCategory = NULL;
		
		var $iLevel0Categories = 0;
		
		var $bCachedRequest = FALSE;
		
		var $arrCategories = array();
		
		
		function SimpleCategoryManager($iCategory=NULL,$bForceUpdate=FALSE)	{
			$this->iCategory = $iCategory;
			$this->GetCategoryStructure($bForceUpdate);
		}

		function SetSortOrder($iSortOrder=CAT_ORDER_NAME)	{
			$this->iSortOrder = $iSortOrder;
			return TRUE;
		}
		
		function SetAgeRestricted($bAgeRestricted=FALSE)	{
			$this->bAgeRestricted = (bool)$bAgeRestricted;
			return TRUE;
		}
		
		function IsRequestCached()	{
			return ($this->bCachedRequest);
		}
		
		function GetLevel0CategoryCount()		{
			return sizeof($this->arrCategories);
		}
		
		function SetCategory($iCategory=NULL,$bForceUpdate=FALSE)	{
			$this->iCategory = $iCategory;
			$this->arrCategories = array();
			$this->GetCategoryStructure($bForceUpdate);
		}
		
		function GetCategoryOverview()		{
			return $this->arrCategories;
		}
		
		
		function GetCategoryStructure($bForceUpdate=FALSE)		{
			
			if($bForceUpdate)	{
				$this->BuildSimpleOverview();
				$this->SaveCache();			
			} else {
				if(!$this->LoadCache())		{
					$this->BuildSimpleOverview();
					$this->SaveCache();
				} else {
					$this->bCachedRequest = TRUE;
				}
			}
			return TRUE;
		}
		
		
		function BuildSimpleOverview()	{
			
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{
				return FALSE;
			}

			// Read categories
			$sql = "SELECT cf_categories.catname, cf_categories.catdesc, cf_categories.catid, cf_categories.caticonlink, ".
				"cf_categories.catagerestricted, cf_catstats.* ".
				"FROM cf_categories ".
				"LEFT OUTER JOIN cf_catstats ON (cf_catstats.statcatid = cf_categories.catid) ".
				"WHERE ".(is_null($this->iCategory)?"isnull(catprev)":"catprev=".$this->iCategory)." ".
				($this->bAgeRestricted?"AND catagerestricted=0 ":"");
				
			switch($this->iSortOrder)	{			
				case CAT_ORDER_NAME:
					$sql.= "ORDER BY catpresort DESC, catname";
					break;
				case CAT_ORDER_NAME_DESC:
					$sql.= "ORDER BY catpresort DESC, catname DESC";
					break;
				case CAT_ORDER_ID:
					$sql.= "ORDER BY catpresort DESC, catid";
					break;
			}
			$CatData = $DB->dbselect($sql);
			
			if(is_array($CatData) && sizeof($CatData)!=0)	{
				foreach($CatData as $element)	{
	
					$oCategory = new SimpleCategory();
					$oCategory->FillFromData($element);
					
					// Get subcategories
					$arrSubCategories = array();							
					
					// Read categories
					$sql = "SELECT cf_categories.catname, cf_categories.catdesc, cf_categories.catid, cf_categories.caticonlink, ".
						"cf_categories.catagerestricted, cf_catstats.* ".
						"FROM cf_categories ".
						"LEFT OUTER JOIN cf_catstats ON (cf_catstats.statcatid = cf_categories.catid) ".
						"WHERE catprev=".$element['catid']." ".
						($this->bAgeRestricted?"AND catagerestricted=0 ":"");
					$SubCatData = $DB->dbselect($sql);
					
					if(is_array($SubCatData) && sizeof($SubCatData))	{
						
						foreach($SubCatData as $SubElement)		{
							$oSubCategory = new SimpleCategory();
							$oSubCategory->FillFromData($SubElement);
							$arrSubCategories[] = $oSubCategory;
						}
					}
					$this->arrCategories[] = array(	"ELEMENT"	=> $oCategory,
													"SUBCATS"	=> $arrSubCategories	);
				
				}
			}
			return TRUE;
		}
				
		
		function SaveCache()	{
			if(!is_array($this->arrCategories))	{
				return FALSE;
			}
			
			if(!is_null($this->iCategory))	{
				$strCacheFile = GetConfig('PD_CACHEDIR')."simplecategory_".
					sprintf("%08d",$this->iCategory).".cch";
			} else {
				$strCacheFile = GetConfig('PD_CACHEDIR')."simplecategory_main.cch";
			}
			
			$hFile = @fopen($strCacheFile,"w");
			if(!$hFile)	{
			return FALSE;
			} else {
				@fputs($hFile,serialize($this->arrCategories));
				fclose($hFile);
			}
			return TRUE;
		}
		
		
		function LoadCache()	{
			
			$strRaw = "";

			if(!is_null($this->iCategory))	{
				$strCacheFile = GetConfig('PD_CACHEDIR')."simplecategory_".
					sprintf("%08d",$this->iCategory).".cch";
			} else {
				$strCacheFile = GetConfig('PD_CACHEDIR')."simplecategory_main.cch";
			}
			
			if(!is_file($strCacheFile) || !is_readable($strCacheFile))	{
				return FALSE;
			}
			
			$hFile = @fopen($strCacheFile,"r");
			if(!$hFile)	{
				return FALSE;
			} else {
				while($buffer=@fgets($hFile,1024))	{
					$strRaw .= $buffer;	
				}
				fclose($hFile);
				
				// Unserialize
				$this->arrCategories = unserialize($strRaw);
				if(!is_array($this->arrCategories))	{
					return FALSE;
				} else {
					return TRUE;
				}
			}

		}
	
		function DeleteCache()		{

			$strDirectory = GetConfig('PD_CACHEDIR');
			if(is_dir($strDirectory))	{
				if($hDir = opendir($strDirectory))	{

					while(($file=readdir($hDir))!=FALSE)	{

						if(strpos(strtoupper($file),"SIMPLECATEGORY")===FALSE)	{
						} else {	
							$file=$strDirectory.$file;						
							unlink($file);						
						}
					}
					closedir($hDir);
				}
			}
			return TRUE;
		}
	
	}
	
	
	class SimpleCategory	{
		
		var $iId = NULL;
		var $strName = "";
		var $strIcon = "";
		var $strDesc = "";
		
		// Statistics
		var $iLevel = 0;
		var $iAdCount = 0;
		var $iAdCountCum = 0;
		var $dtLastIn = 0;
		var $dtLastInCum = 0;
		var $iChildCatCount = 0;
		
		var $bAgeRestricted = FALSE;
		
		
		function FillFromData($element)		{
			
			$this->iId = $element['catid'];
			$this->strName = $element['catname'];
			$this->strIcon = $element['caticonlink'];
			$this->strDesc = $element['catdesc'];
			$this->bAgeRestricted = $element['catagerestricted'];
			
			if(!is_null($element['statid']))	{
				$this->iLevel = $element['statlevel'];
				$this->iAdCount = $element['statadcount'];
				$this->iAdCountCum = $element['statadcountcum'];
				$this->dtLastIn = $element['statlastin'];
				$this->dtLastInCum = $element['statlastincum'];
				$this->iChildCatCount = $element['statchildcatcount'];
			}
			return TRUE;
		}

	}

	
	class CategoryWorks		{
		
		function GetPathToCategory($iCategory=NULL)		{

			$arrPath = array();
			
			// Top level category no path available
			if(is_null($iCategory))	{
				return $arrPath;
			}
			
			// Get database access
			$DB = new SQLDatabase();
			if(!$DB->dbconnect())	{
				return $arrPath;
			}
			
			// Get path
			while(!is_null($iCategory))	{
			
				$sql = "SELECT cf_categories.catname, cf_categories.catdesc, cf_categories.catid, cf_categories.caticonlink, ".
						"cf_categories.catagerestricted, cf_categories.catprev, cf_catstats.* ".
						"FROM cf_categories ".
						"LEFT OUTER JOIN cf_catstats ON (cf_catstats.statcatid = cf_categories.catid) ".
						"WHERE catid=".$iCategory." ";		
				$data = $DB->dbselect($sql);

				if(is_array($data) && sizeof($data)>0)	{
					$iCategory = $data[0]['catprev'];					
					
					$oCategory = new SimpleCategory();
					$oCategory->FillFromData($data[0]);
					$arrPath[] = $oCategory;

				} else {
					$iCategory = NULL;
				}
			}
			return array_reverse($arrPath);		
		}
		
		
		
		
	}
	
	
	//
	//	COMMON CATEGORY FUNCTIONS
	//
	
	// Build subcategory links from array
	function BuildSubCatsFromArray($arrSubs="",$iMax=5,$bArtCount=TRUE,$Security=TRUE)	{
		
		if($iMax==0 || !is_array($arrSubs) || sizeof($arrSubs)==0)	{ 
			return "&nbsp;"; 
		}

		$iSubCategories = sizeof($arrSubs);
		$iMaxCounter = 0; 
		$strRet = "";

		foreach($arrSubs as $oCategory)	{

			if(!$oCategory->bAgeRestricted || ($oCategory->bAgeRestricted && !$Security))	{
				
				// Mark categories as age restricted
				if($oCategory->bAgeRestricted)	{
					$AgeRestIcon = "<img src= \"".GetConfig('PD_SCRIPTGRAPHICS')."alert.gif\" alt=\"".
						LANG_INDEXNEWARTICONAGE."\">&nbsp;";
				} else { 
					$AgeRestIcon=""; 
				}
				
				if(!empty($strRet))	{ 
					$strRet .= " - "; 
				}
				
				$strRet.= "<nobr>".$AgeRestIcon."<a href=\"showads.php?catid=".$oCategory->iId."\">".
					$oCategory->strName."</a>".
					($bArtCount?" (".($oCategory->iAdCountCum + $oCategory->iAdCount).")":"").
					"</nobr>";
				
				$iMaxCounter++;
				if($iMaxCounter > $iMax)	{
					$strRet.= ($iSubCategories > $iMax?" - ...":"");
					break;
				}
			}
		}
		return $strRet;
	}
	
	
	function BuildCatHistory($iCatId=NULL)		{
		
		$strRet = "";
		
		$oCatWorks = new CategoryWorks();
		$arrPath = $oCatWorks->GetPathToCategory($iCatId);
		
		if(is_array($arrPath) && sizeof($arrPath)>0)	{
			foreach($arrPath as $oCategory)		{
				$strRet.= "&nbsp;&gt;&nbsp".
					"<a href=\"showads.php?catid=".$oCategory->iId."\">".
					$oCategory->strName."</a>";
			}
		}
		return $strRet; 
	}
	
	

	
}	
?>