<?php

	define("CAPTCHA_AUTO",0);
	define("CAPTCHA_MATH",1);
	define("CAPTCHA_MATHTEXT",2);
	define("CAPTCHA_QUESTION",3);
	define("CAPTCHA_LETTER",4);
	
	
	class TextCaptcha	{

		var $iType = CAPTCHA_AUTO;
		
		var $strCaptchaText = "";
		var $strCaptchaSolution = "";
		
		/*
			Letter captcha config
		*/
		var $iMaxChars = 3;
		var $bNumberFulltext = TRUE;
		var $bNumberRandom = TRUE;

		
		/*
			Constructor
		*/
		function TextCaptcha($iType=CAPTCHA_AUTO)	{
			$this->iType = $iType;
		}
		
		
		/*
			Public functions
		*/
		function BuildCaptcha()	{

			if($this->iType==CAPTCHA_AUTO)	{
				$this->iType = rand(1,4);
			}
			
			// No more captcha types included, so create a letter captcha
			$this->CreateLetterCaptcha();

			return TRUE;		
		}
		
		
		/*
			Access captcha parameter
		*/
		function GetQuestion()	{
			return $this->strCaptchaText;
		}
		
		function GetSolution()	{
			return $this->strCaptchaSolution;
		}
		
		
		function SetMaxChars($iChars)	{
			$this->iMaxChars = (integer)$iChars;
			return TRUE;
		}
		
		
		/*
			Protected methods	
		*/
		function CreateLetterCaptcha()		{
			
			if($this->iMaxChars<=0)		{
				$this->iMaxChars = 1;
			}
			
			// Get random word
			$iKey = array_rand($GLOBALS['CAPTCHA']['WORDLIST']);
			$strWord = $GLOBALS['CAPTCHA']['WORDLIST'][$iKey];
			
			if($this->iMaxChars > strlen($strWord))	{
				$this->iMaxChars = strlen($strWord);
			}

			// Select random, unique letter from selected word and sort the list
			$arrSelected = array();
			do {
				$iRand = rand(0,strlen($strWord)-1);
				if($iRand<=10)	{
					$arrSelected[] = $iRand;
					$arrSelected = array_unique($arrSelected);
				}
			} while (sizeof($arrSelected)<$this->iMaxChars);
			sort($arrSelected);
			
			// Create solution string
			$this->strCaptchaSolution = "";
			for($i=0;$i<sizeof($arrSelected);$i++)	{
				$this->strCaptchaSolution.= substr($strWord,$arrSelected[$i],1);
			}
			
			// Create captcha question
			// Convert index based to human readable positions			
			$arrPositions = array();
			foreach($arrSelected as $iIndex)	{
				$arrPositions[] = $iIndex +1;
			}

			// Convert all or random positions from number to text		
			if($this->bNumberFulltext)	{
				for($i=0;$i<sizeof($arrPositions);$i++)	{					
					if(!$this->bNumberRandom || (boolean)rand(0,1))	{			
						$arrPositions[$i] = NumberToText($arrPositions[$i]);
					}
				}
			}
			
			if($this->iMaxChars==1)		{
				$this->strCaptchaText = 
					sprintf($GLOBALS['CAPTCHA']['LETTERTEXTS']['SINGLE'],
					$arrPositions[0],
					strtoupper($strWord));
			} else {
				// Multiple chars
				$this->strCaptchaText = 
					sprintf($GLOBALS['CAPTCHA']['LETTERTEXTS']['MULTI'],
					strtolower(implode(", ",array_slice($arrPositions,0,sizeof($arrPositions)-1))),
					strtolower($arrPositions[(sizeof($arrPositions)-1)]),					
					strtoupper($strWord));
			}
			return TRUE;
		}
	}	
		
	
	/*
		Upcoming version information
	*/
	$GLOBALS['CAPTCHA']['MATHQUESTIONS'] = array( 
		"ADD" => array( 
			"Was ergibt sich, wenn man %1 und %2 addiert?",
			"Welche Zahl ergibt sich, wenn man %1 zu %2 hinzufgt?",
			"17+4 ist ein Kartenspiel, aber was ergibt %1 zuzglich %2?"),
		"SUB" => array(
			"Substrahieren Sie %1 von %2?",
			"Ziehen Sie %1 von der Zahl %3 ab. Was ergibt sich?"
		)
	);
	
?>