<?php		

	/**
	 *	Insert new ad (user)
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */

	require "inc/includer.inc.php";
	require_once("inc/countries.inc.php");
	require_once("inc/guielements.inc.php");
	require_once("inc/badword.class.php");
	require_once("inc/picture.class.php");
	require_once("inc/picturelist.class.php");
	require_once("inc/postoffice.class.php");
	
	
	// Try to extend the max. execution time
	// Works only, if PHP-server is NOT configured for safe-mode
	if(!(boolean)ini_get('safe_mode'))		{
		@set_time_limit(180);
	}
	
	// Check security options - allowed to post an ad directly?
	function CheckSecurity()	{

		// Check, if direct submit is allowed
		$DirectSubmit = 0;
		
		// Allow direct submit?!
		if(GetConfig('SEC_DIR_SUB_UNKNOWN')==false && is_array($_SESSION['s_UserInfo'])==false)	{
			// Unknown user, no right to submit directly
			$DirectSubmit = 0;
		} elseif(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))		{
			// Known user, check rights	
			if(		($_SESSION['s_UserInfo']['userrights']& 1 && GetConfig('SEC_DIR_SUB_USER'))
				|| 	($_SESSION['s_UserInfo']['userrights']& 2 && GetConfig('SEC_DIR_SUB_AUTHUSER'))
				|| 	($_SESSION['s_UserInfo']['userrights']&16 && GetConfig('SEC_DIR_SUB_COMMERCIAL'))
				|| 	($_SESSION['s_UserInfo']['userrights']&64 || $_SESSION['s_UserInfo']['userrights']&128))			
			{
				// Normal user, Auth user, Comm user (all with permission) or (Debug-)Admins
				$DirectSubmit = 1;
			}
		} elseif(!is_array($_SESSION['s_UserInfo']))	{
			$DirectSubmit = (GetConfig('SEC_DIR_SUB_UNKNOWN') ? "1":"0");	
		}
		return $DirectSubmit;				// 0 -> not allowed, 1-> Allowed
	}
	
			
	// Add an ad to the database		
	function AddToDatabase($PicLink="")		{

		// Add Advertisment to Database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		
		if($DB==false)	{
			echo LANG_DBCONNECTERRORCUST;
			die();
		}
		$RetVal = $DB->dbinsert(BuildSQLString($PicLink));
		if($RetVal)		{
			LogActions("MSGA","Msg-ID: ".$RetVal." - Titel: ".$_POST['f_title'].
				" - IP: ".$_SERVER['REMOTE_ADDR'],$_SESSION['s_UserInfo']['userid']);	
			
			// Free Field to database
			if(GetConfig('USE_FREE_FIELDS'))		{
				if(($DB->dbinsert(BuildFFSQLString($RetVal))==false) && (GetConfig('DEBUG')))	{
					ShowErrorMessage("Problems inserting free field data!");	
				}
			}
		} 
		return $RetVal;
	}

	// Build SQL String to insert FreeField data
	function BuildFFSQLString($iAdId=0)		{

		if($iAdId <=0)		{ return false;	}
		
		$sql = "INSERT INTO cf_adfreerows ".
			"(adid, freecol01,freecol02,freecol03,freecol04,freecol05,".
			"freecol06,freecol07,freecol08,freecol09,freecol10,freecoldesc) VALUES (".
			"'".$iAdId."','".(isset($_POST['f_field1'])?$_POST['f_field1']:"")."','".
			(isset($_POST['f_field2'])?$_POST['f_field2']:"")."','".
			(isset($_POST['f_field3'])?$_POST['f_field3']:"")."','".
			(isset($_POST['f_field4'])?$_POST['f_field4']:"")."','".
			(isset($_POST['f_field5'])?$_POST['f_field5']:"")."','".
			(isset($_POST['f_field6'])?$_POST['f_field6']:"")."','".
			(isset($_POST['f_field7'])?$_POST['f_field7']:"")."','".
			(isset($_POST['f_field8'])?$_POST['f_field8']:"")."','".
			(isset($_POST['f_field9'])?$_POST['f_field9']:"")."','".
			(isset($_POST['f_field10'])?$_POST['f_field10']:"")."','".
			GetFreeFields(0,true,true)."')";
		
		return $sql;		
	}

	// Build SQL String to insert "normal" field data into the database
	function BuildSQLString($PicLink="")		{
		
		// Duration of advertisment, for security reason in this way:
		$days =30;
		switch(strtoupper($_POST['f_duration']))	{
			case "7DAYS":
				$days=7; break;
			case "14DAYS":
				$days=14; break;
			case "60DAYS":
				$days=60; break;
			case "180DAYS":
				$days=180; break;
			case "360DAYS":
				$days=360; break;				
			case "UNLIMITED":
				$days=3600;	break;
		}
		$adoutdate = date("Y.m.d H:i:s", time()+$days*86400);

		// Delete all tags from textbody	
		$text = @strip_tags($_POST['f_text']);
		$title = @strip_tags($_POST['f_title']);
		
		// Build string
		$RetVal = "INSERT INTO cf_ads ".
			"(adicq,adindate,adoutdate,adtitle,adtext,adtel,ademail,adzip,adcountry,adcat, ".
			"adname,adfax,adlang,adcity,admobile,adipadress,adpiclink,aduserid,adchecked,adagerestricted, ".
			"adyahoo, adaim, adskype, admsn, adhomepage, adtype) VALUES ('".
			$_POST['f_icq']."',now(),'".$adoutdate."','".$title."','".$text."','".
			$_POST['f_tel']."','".$_POST['f_email']."','".$_POST['f_zip']."','".
			$_POST['f_country']."',".$_POST['f_category'].",'".$_POST['f_name']."','".
			$_POST['f_fax']."',1,'".$_POST['f_city']."','".$_POST['f_mobile']."','".
			$_SERVER['REMOTE_ADDR']."','".$PicLink."','".$_SESSION['s_UserInfo']['userid']."',".
			CheckSecurity().",".(isset($_POST['f_agerestricted']) && strtoupper($_POST['f_agerestricted'])=="YES"?"1":"0").",'".
			$_POST['f_yahoo']."','".$_POST['f_aim']."','".$_POST['f_skype']."','".$_POST['f_msn']."','".
			$_POST['f_website']."',".$_POST['f_adtype'].")";
			
		return $RetVal;	
	}



	// Start display
	$PageTitle = GetPageTitle(LANG_TTLNEWAD);

	// Header senden
	include "inc/header.inc.php";
	
	//
	// Init variables
	//
	$bError=false;
	$strMessage = "";
	$BreadCrumb = "";
	$oPicList = NULL;
	
	// Create / use Error arrays
	$arrError = array( 	"nametest"		=> TRUE,
						"citytest"		=> TRUE,
						"emailtest"		=> TRUE,
						"categorytest"	=> TRUE,
						"adtypetest"	=> TRUE,
						"titletest"		=> TRUE,
						"texttest"		=> TRUE,
						"picturetest"	=> TRUE 	);			
		
	// Create and use Free field errors
	if(GetConfig('USE_FREE_FIELDS'))	{
		$arrFreeError = array();
		for($i=1; $i<=10; $i++)	{
			$arrFreeError[$i]=true;			
		}
	}
	
	// Check security
	if(GetConfig('SEC_FORCE_AGE_REST') && GetConfig('SEC_HIDE_AGEREST_CATS') && 
		(isset($_SESSION['s_UserInfo']['useragechecked']) && $_SESSION['s_UserInfo']['useragechecked']!="1"))	{
		$AgeRestricted = true;
	} else { 
		$AgeRestricted = false; 
	}
	
	// Show debug output
	if(GetConfig('DEBUG'))	{	
		if(CheckSecurity() == "1")	{ echo "Direct Submit: ALLOWED!"; } else { echo "Direct Submit: NOT ALLOWED!"; }
	}
	
	// Check user rights
	if(GetConfig('SEC_SUB_UNKNOWN') || 
		(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo'])))	{
	
	} else {
		// User has no rights to submit ads
		$bError=true;
		$_SESSION['LoginMessage'] = LANG_LOGINSUBMITNOTALLOWED;;
		$_SESSION['RedirectTarget'] = $_SERVER['REQUEST_URI'];
		
		$RedirectTag = "<meta http-equiv=\"refresh\" content=\"0; URL=userlogin.php\">";
		include "inc/header.inc.php";
		die();
	}
	
	
	// Deserialize picturelist
	if(isset($_SESSION['s_picturelist']))	{
		$oPicList = unserialize($_SESSION['s_picturelist']);
		if(!is_object($oPicList) || is_null($oPicList))	{
			$oPicList = new PictureList();
		}
	} else {
		$oPicList = new PictureList();
	}
	
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES")	{
		
		if(isset($_POST['f_upload']))	{
			// Add picture
			
			// Do Pictureforming, if picture name is given
			if(GetConfig('LY_ENABLEARTICLEPICS'))		{

				if($oPicList->Count() >= GetConfig('SEC_MAX_PICS_PER_AD'))	{
					$bError = TRUE;
					$strMessage = LANG_UPLOAD_ERR_MAX_PICS_REACHED;
				} else {
					
					// Upload picture		
					require_once("inc/picturehandler.class.php");
					$oPH = new PictureHandler($_FILES['f_uploadpic'],GetConfig('LY_MAX_UPLOAD_SIZE')*1024);
					$iRetVal = $oPH->Process();
		
					if($iRetVal<=0)		{
		
						$bError = TRUE;
						$arrError['picturetest'] = FALSE;			
						
						switch($iRetVal)	{
							case ERR_PH_NO_PICTURE:
								$strMessage = LANG_NEWADPICFORMATERROR;					
								break;
							case ERR_PH_MOVE_FAILED:
								$strMessage = LANG_NEWADUPLOADCOPYERROR;
								break;	
							case ERR_PH_TOO_BIG:
								$strMessage = ParseIn(LANG_NEWADPICERROR,sprintf("%d",GetConfig('LY_MAX_UPLOAD_SIZE')));
								break;
							case ERR_PH_PARTITAL:
								$strMessage = LANG_UPLOADERRORPARTITIAL;
								break;
							case ERR_PH_NO_UPLOAD:
								$strMessage = LANG_UPLOADERRNOFILE;
								break;
						}
					} else {
						/* @var $oPic Picture */
						$oPic = new Picture();
						$oPic->strTitle =  toSafeString($_POST['f_piccomment']);
						$oPic->strLink = $oPH->GetFilename();
						$oPic->iId = (integer)microtime(TRUE)*10000;
						$oPic->iAdId = -1;
						$oPic->bReleased = (GetConfig('SEC_USE_PIC_RELEASE')?FALSE:TRUE);
						$oPicList->AddPicture($oPic);
					}
				}
			}
			
			$_SESSION['s_picturelist'] = serialize($oPicList);
		} elseif(isset($_POST['f_delete']))	{	
			
			// Remove from list
			if(isset($_POST['f_dellist']) && is_array($_POST['f_dellist']) && sizeof($_POST['f_dellist'])>0)	{
				$oPicList->RemoveByArray($_POST['f_dellist']);
			}
			$_SESSION['s_picturelist'] = serialize($oPicList);
			
			
		} else {
						
			//
			// Convert and check form values
			//
			$_POST['f_icq'] = toSafeString($_POST['f_icq']);
			$_POST['f_yahoo'] = toSafeString($_POST['f_yahoo']);
			$_POST['f_msn'] = toSafeString($_POST['f_msn']);
			$_POST['f_skype'] = toSafeString($_POST['f_skype']);
			$_POST['f_aim'] = toSafeString($_POST['f_aim']);
			$_POST['f_title'] = toSafeString($_POST['f_title']);
			$_POST['f_text'] = toSafeString($_POST['f_text']);
			$_POST['f_tel'] = toSafeString($_POST['f_tel']);
			$_POST['f_email'] = toSafeString($_POST['f_email']);
			$_POST['f_zip'] = toSafeString($_POST['f_zip']);
			$_POST['f_country'] = toSafeString($_POST['f_country']);
			$_POST['f_category'] = toInt($_POST['f_category']);
			$_POST['f_adtype'] = toInt($_POST['f_adtype']);
			$_POST['f_name'] = toSafeString($_POST['f_name']);
			$_POST['f_fax'] = toSafeString($_POST['f_fax']);
			$_POST['f_city'] = toSafeString($_POST['f_city']);
			$_POST['f_mobile'] = toSafeString($_POST['f_mobile']);
			$_POST['f_website'] = toSafeString($_POST['f_website']);
			$_POST['f_website'] = CropProtocol($_POST['f_website']);
			
			//	
			// Test mandatory fields
			//
			if(empty($_POST['f_name']))		{ $arrError['nametest']=false; }
			if(empty($_POST['f_city']))		{ $arrError['citytest']=false; }
			if(empty($_POST['f_email']))	{ $arrError['emailtest']=false; }
			if($_POST['f_category']==(-1))	{ $arrError['categorytest']=false; }
			if($_POST['f_adtype']==(-1))	{ $arrError['adtypetest'] = false; }
			if(empty($_POST['f_title']))	{ $arrError['titletest']=false; }
			if(empty($_POST['f_text']))		{ $arrError['texttest']=false; }
					
			foreach($arrError as $element)	{ 
				if(!$element) { $bError=true; }
			}
			
			//
			// Test freefield mandatory
			//
			if(GetConfig('USE_FREE_FIELDS'))		{
	
				if(isset($_SESSION['s_FFConfig']) && is_array($_SESSION['s_FFConfig']))		{
								
					$Fields = DecodeFreeFieldDefinitions($_SESSION['s_FFConfig'][0]['ColumnConfig'],"","",false);	
							
					$i=1;
					foreach($Fields as $FieldRow)		{	
						// Check all used fields
						$strField = "f_field".$i;
						
						if(isset($FieldRow['useit']) && $FieldRow['useit']==TRUE)	{
							// Check free field mandatory
							if($FieldRow['mand'] && empty($_POST[$strField]))	{
								$arrFreeError[$i] = FALSE;
							}
						}
						$i++;
					}
					foreach($arrFreeError as $element) {
						if($element==false)	{ $bError=true; }
					}
				}
			}
	
			if($bError==true)	{ 
				$strMessage = LANG_NEWADMANDATORYERROR; 
			}
		
			// Test Email-Adress
			if (!$bError && !eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$_POST['f_email']))		{
	  			$bError = TRUE;
	  			$arrError['emailtest'] = FALSE;
	  			$strMessage = LANG_NEWADEMAILERROR; 
			}
	  		  		
			// Check for bad words
			if(!$bError)	{
	
				$oBadWord = new BadWords($GLOBALS['BAD_WORD_LIST']);
				if(!$oBadWord->CheckText($_POST['f_text']) || !$oBadWord->CheckText($_POST['f_title']))	{
					// Found bad words
					$bError = TRUE;
					$strMessage = ParseIn(LANG_ERRBADWORDFOUND,implode(" / ",$oBadWord->GetFoundArray()));				
				}
			}
			
			
			// If everything is okay, add to database	
			if(!$bError) 	{
				
				// Get preview picture link
				$LinkName = $oPicList->GetFirstLink();
				
				$iAdId = AddToDatabase($LinkName);
				if(!$iAdId)	{
					// An error occured while writing to database
					$bError = TRUE;
					$strMessage = LANG_NEWADADDERROR;
				} else {
					
					// Save picture list
					if($oPicList->Count()>0)	{
						$oPicList->InsertList($iAdId);
					}
					
					// Everything worked properly
					$strMessage = LANG_NEWADADDSUCCESS;
								
					if(CheckSecurity())	{
						
						if(GetConfig('SEC_SUB_ADMIN_INFO'))	{
							// Send information mail to Admin
							SendAdCheckRequest($iAdId,TRUE);
						}
						
						// Link to submitted ad, but only, if direct submit was allowed
						$strMessage.=  "<br><a href=\"showad.php?adid=".$iAdId."\">".LANG_LINKTOMYAD."</a>";
					} else {
						// Send release mail to Admin
						SendAdCheckRequest($iAdId,FALSE);
						$strMessage.= LANG_RELADSINFORMATION;	
					}
					$strMessage .= "<br><a href=\"showads.php?catid=".$_POST['f_category']."\">".LANG_LINKTOMYADSCAT."</a>";				
					
					$_SESSION['s_picturelist'] = NULL;
					
					include "templates/".$GLOBALS['ACTIVELANGUAGE']."/success.tpl.php";
					include "inc/footer.inc.php";
					die();
				}
			}	
		
		}
		
	} else {
		// First display
		
		// Fill known userdata into fields
		if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))		{
			
			$_POST['f_name'] = $_SESSION['s_UserInfo']['userrealname'];
			$_POST['f_zip'] = $_SESSION['s_UserInfo']['userzip'];
			$_POST['f_city'] = $_SESSION['s_UserInfo']['usercity'];
			$_POST['f_country'] = $_SESSION['s_UserInfo']['usercountry'];
			$_POST['f_tel'] = $_SESSION['s_UserInfo']['usertel'];
			$_POST['f_icq'] = $_SESSION['s_UserInfo']['usericq'];
			$_POST['f_mobile'] = $_SESSION['s_UserInfo']['usermobile'];
			$_POST['f_fax'] = $_SESSION['s_UserInfo']['userfax'];
			$_POST['f_email'] = $_SESSION['s_UserInfo']['useremail'];
			$_POST['f_website'] =  $_SESSION['s_UserInfo']['userhomepage'];
			$_POST['f_yahoo'] =  $_SESSION['s_UserInfo']['useryahoo'];
			$_POST['f_aim'] =  $_SESSION['s_UserInfo']['useraim'];
			$_POST['f_msn'] =  $_SESSION['s_UserInfo']['usermsn'];
			$_POST['f_skype'] =  $_SESSION['s_UserInfo']['userskype'];
			
			$_SESSION['s_picturelist'] = NULL;
			unset($_SESSION['s_picturelist']);
			
		}
		
		// Default length
		$_POST['f_duration'] = "30days";
		$_POST['f_category'] = -1;
		$_POST['f_adtype'] = -1;
		
		// Include New Advertisment Form
		if(GetConfig('USE_FREE_FIELDS'))	{
			$_SESSION['s_FFConfig']=GetFreeFields(0,true);
		}
	}
	
	//
	// Display form	
	//
	$ImgError = "<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."x.gif\" valign=\"center\">";
	$BreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
		"&nbsp;&gt;&nbsp;".LANG_INPTTLNEWAD;
	$strCountrySelect = GetCountriesForDropDown($_POST['f_country']);
	$strDurationSelect = GetDurationForDropDown($_POST['f_duration'], GetConfig('UNLIMITED_ADS'));
	$strAdTypeSelect = GetAdTypesForDropDown($_POST['f_adtype'],TRUE);
	$bShowClosedUserGroup = (isset($_SESSION['s_UserInfo']['useragechecked']) && 
		$_SESSION['s_UserInfo']['useragechecked']?TRUE:FALSE);
	

	// Build picture list
	if(GetConfig('LY_ENABLEARTICLEPICS'))	{
		$strPictureList = GetPictureEditList($oPicList);
	}
		
	// Free field handling
	if(GetConfig('USE_FREE_FIELDS'))		{
		if(isset($_SESSION['s_FFConfig']) && is_array($_SESSION['s_FFConfig']))	{ 
			
			// Copy all freefield data into array first
			$ArrayValue = array();
			for($i=1;$i<=10;$i++)	{
				$ArrayValue[$i]=(isset($_POST["f_field$i"])?$_POST["f_field$i"]:"");	
			}
			
			// Build FreeFieldDefinitions for form use
			foreach($_SESSION['s_FFConfig'] as $Column)		{
				$FreeField = DecodeFreeFieldDefinitions($Column['ColumnConfig'], $ArrayValue, $arrFreeError, true);
			}
		}
	}	
	
	if(GetConfig('OP_SIMPLE_CATS'))	{
		$strCategorySelect = GetCategoriesForSelect($_POST['f_category'],$AgeRestricted,true);
	} else {
		// Complexe cats
		require_once("inc/adv_categories.inc.php");
		
		$oCatManager = new CatTreeManager();
		$oRoot = $oCatManager->GetTreeRoot();
		
		$oTreeWork = new CategoryTreeWorks($oRoot);
		$strCategorySelect = $oTreeWork->GetCategoryForSelect($_POST['f_category'],TRUE);
	}

	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/newad.tpl.php";
	include "inc/footer.inc.php";

?>