<?php

	/**
	 *	Display ad details
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	

	require "inc/includer.inc.php";
	require_once("inc/picture.class.php");
	require_once("inc/picturelist.class.php");


	// Header senden
	$PageTitle = GetPageTitle(LANG_TTLSHOWADPICTURES);
	include "inc/header.inc.php";
	
	
	//
	// Init variables
	//
	$iAdID = -1;
	$iPictureIndex = 0;
	$strBreadCrumb = "";

	
	//
	// Get ad id
	//
	if(isset($_GET['adid']))	{
		$iAdID = (integer)$_GET['adid'];
	}
	
	if($iAdID<=0)	{
		echo LANG_PAGEPARAMETERERROR;	
		die();
	} 

	//
	// Get picture index
	//
	if(isset($_GET['pindex']))	{
		$iPictureIndex = (integer)$_GET['pindex'];		
	}
	
	//
	// Read article from database - secure mode
	//

	$data = GetArticleByID($iAdID,TRUE);
	if(!is_array($data) || sizeof($data)==0)	{	
		echo LANG_PAGEPARAMETERERROR;	
		die();
	}

	$arrAdData = $data[0];

	// Get category information
	$CatArray = GetCategorieByID($arrAdData['adcat']);
	
	//
	// Security checks
	//
	if(!$arrAdData['adchecked'])		{ 
		if(isset($_SESSION['s_UserInfo']))		{
			if(!$_SESSION['s_UserInfo']['userrights'] & 64 || !$_SESSION['s_UserInfo']['userrights'])	{		
				echo LANG_ADVIEWNOTCHECKED;
				die();			
			}
		} else {
			echo LANG_ADVIEWNOTCHECKED;
			die();			
		}
	}
	
	// Check age restriction of ad and category
	if(GetConfig('SEC_FORCE_AGE_REST') && 
		($CatArray['catagerest']==1 || $arrAdData['adagerestricted']==1 ))	{
		
		// Yes, we have to check the age of user
		if(!isset($_SESSION['s_UserInfo']) || !is_array($_SESSION['s_UserInfo']) || 
			$_SESSION['s_UserInfo']['useragechecked']!=1)		{
			// Not allowed to view ad	
			echo LANG_ADVIEWNOTALLOWED;
			die();
		}
	}	
	
	// Check age restriction of ad and category
	if(GetConfig('SEC_FORCE_AGE_REST') && 
		($CatArray['catagerest']==1 || $arrAdData['adagerestricted']==1 ))	{
		
		// Yes, we have to check the age of user
		if(!isset($_SESSION['s_UserInfo']) || !is_array($_SESSION['s_UserInfo']) || 
			$_SESSION['s_UserInfo']['useragechecked']!=1)		{
			// Not allowed to view ad	
			echo LANG_ADVIEWNOTALLOWED;
			die();
		}
	}

	//
	// Get picture list
	//
	$oPictureList = new PictureList();
	$oPictureList->ReadList($iAdID);
	$arrPictures = $oPictureList->GetPicArray();

	
	//
	// Build vars
	//	
	$strViewTitle = $arrAdData['adtitle'];
	
	if(is_array($arrPictures) && sizeof($arrPictures)>0)	{
		
		if(array_key_exists($iPictureIndex,$arrPictures))	{
			$oBigPic = $arrPictures[$iPictureIndex];
		} else {
			$oBigPic = $arrPictures[0];
		}
		
		if(GetConfig('SEC_USE_PIC_RELEASE') && !$oBigPic->bReleased)	{
			$strBigPictureLink = "<b>".LANG_PICTURE_NOT_RELEASED."</b>";	
		} else {
			$strBigPictureLink = "<img name=\"bigimage\" id=\"bigimage\" ".
				"src=\"".GetConfig('PD_USERGRAPHICS').$oBigPic->strLink."\" ".
				"alt=\"".$oBigPic->strTitle."\">";
		}
				
		$strPictureDescription = (empty($oBigPic->strTitle)?LANG_PICTURE_NO_DESCRIPTION:$oBigPic->strTitle);
		
	} else {
		// No pictures?! What the hell happend here?
		
		
	}
	
	// Thumbnails
	$strThumbList = "";
	foreach($arrPictures as $key=>$oPic)	{

		/* @var $oPic Picture */
		if(GetConfig('SEC_USE_PIC_RELEASE') && !$oPic->bReleased)	{
			// Display locked image
			$strThumbList.= "<div id=\"adpicthumb\">".
				"<img src=\"".GetConfig('PD_SCRIPTGRAPHICS')."locked_image.jpg\" alt=\"".LANG_PICTURE_NOT_RELEASED."\">".
				"</div>";
		} else {
			
			$strAlt = (empty($oPic->strTitle)?LANG_PICTURE_NO_DESCRIPTION:$oPic->strTitle);
			
			$strThumbList.= "<div style=\"width:90px; float:left; text-align:center;\">".
				"<a href=\"showadpictures.php?adid=".$oPic->iAdId."&pindex=".$key."\">". 
				"<img src=\"".GetConfig('PD_USERGRAPHICS')."tn_".$oPic->strLink."\" alt=\"".$strAlt."\" >".
				"</a>".
				"</div>";	
		}
	}

	
	//
	// Show template
	//
	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/showadpictures.tpl.php";
	
	
?>